<PROLOGUE>
<![CDATA[

]]>
</PROLOGUE>


<KSID>
  <Type>Action</Type>
  <Name>Action_AlarmPoint</Name>
  <Desc>Send a message to the AlarmPoint notification system.</Desc>
  <Version>
    <AppManID>6.1</AppManID>
    <KSVerID>1.0</KSVerID>
  </Version>
  <NeedPWD>0</NeedPWD>
  <AdminOnly>0</AdminOnly>
  <UnixOnly>0</UnixOnly>
  <DataSrcID>0</DataSrcID>
  <Platform>-1</Platform>
  <OptionExplicit>0</OptionExplicit>
</KSID>

<ObjType fullpath="0" dropfolderlist="0" styleversion="3">
  <Type name="NT_MachineFolder"></Type>
</ObjType>

<Schedule>
  <Default type="runonce" runmode="sched"></Default>
  <Allowed>
    <RunOnce>1</RunOnce>
    <IntervalIter>1</IntervalIter>
    <Daily>1</Daily>
    <Weekly>1</Weekly>
    <Monthly>1</Monthly>
  </Allowed>
</Schedule>

<DataSrc></DataSrc>

<Parameter>
  <Desc>Sends a message to AlarmPoint critical event notification system. If Repository Server is left blank, then LOCAL SERVER is assumed. SQL Login and Password are required for NON LOCAL SERVER</Desc>
  <Param name="ActionScriptSet">
    <Desc>Action Script Set to run on AlarmPoint</Desc>
    <Delim>,</Delim>
    <Type>String</Type>
    <Size>80</Size>
    <Value>AppManager</Value>
    <ReqInput>0</ReqInput>
    <Folder>0</Folder>
    <NoQuote>0</NoQuote>
  </Param>
  <Param name="PersonOrGroupID">
    <Desc>AlarmPoint Person or Group ID to notify</Desc>
    <Delim>,</Delim>
    <Type>String</Type>
    <Size>80</Size>
    <Value>9999</Value>
    <ReqInput>0</ReqInput>
    <Folder>0</Folder>
    <NoQuote>0</NoQuote>
  </Param>
  <Param name="RepositoryServerName">
    <Desc>AppManager Repository Server</Desc>
    <Delim>,</Delim>
    <Type>String</Type>
    <Size>80</Size>
    <ReqInput>0</ReqInput>
    <Folder>0</Folder>
    <NoQuote>0</NoQuote>
  </Param>
  <Param name="RepositoryDatabaseName">
    <Desc>AppManager Database Name</Desc>
    <Delim>,</Delim>
    <Type>String</Type>
    <Size>80</Size>
    <ReqInput>0</ReqInput>
    <Folder>0</Folder>
    <NoQuote>0</NoQuote>
  </Param>
  <Param name="AlarmPointLoginID">
    <Desc>AlarmPoint Login ID</Desc>
    <Delim>,</Delim>
    <Type>String</Type>
    <Size>80</Size>
    <Value>AlarmPoint</Value>
    <ReqInput>0</ReqInput>
    <Folder>0</Folder>
    <NoQuote>0</NoQuote>
  </Param>
  <Param name="AlarmPointLoginIDPassword">
    <Desc>AlarmPoint Login ID Password</Desc>
    <Delim>^</Delim>
    <Type>String</Type>
    <Size>128</Size>
    <Value>alarmpoint</Value>
    <ReqInput>0</ReqInput>
    <I_Type>I_EDIT(1)</I_Type>
    <Folder>0</Folder>
    <NoQuote>0</NoQuote>
  </Param>
 <Param name="FDR_CustomMessageOptions">
    <Desc>Custom Message Options</Desc>
    <ReqInput>0</ReqInput>
    <Parent>FDR_Action</Parent>
    <Folder>1</Folder>
    <NoQuote>0</NoQuote>
  </Param>

  <Param name="EventMsgOverride">
    <Desc>Override the Event Message with this text</Desc>
    <Delim>,</Delim>
    <Type>String</Type>
    <Size>200</Size>
    <ReqInput>0</ReqInput>
    <Parent>FDR_CustomMessageOptions</Parent>
    <Folder>0</Folder>
    <NoQuote>0</NoQuote>
  </Param>
  <Param name="EventIDOverride">
    <Desc>Override the EventID with this EventID</Desc>
    <Delim>,</Delim>
    <Type>String</Type>
    <Size>80</Size>
    <ReqInput>0</ReqInput>
    <Parent>FDR_CustomMessageOptions</Parent>
    <Folder>0</Folder>
    <NoQuote>0</NoQuote>
  </Param>
</Parameter>

<ActionDef></ActionDef>

<AdvanceConfig></AdvanceConfig>

<ScriptDef>
  <Script language="BasicScript">
<![CDATA[
Const Tic As String = "'"
Const DoubleTic As String = """"
Const OneSpace As String = " "

Type STARTUPINFO
    cb As Long
    lpReserved As String
    lpDesktop As String
    lpTitle As String
    dwX As Long
    dwY As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Integer
    cbReserved2 As Integer
    lpReserved2 As Long
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
End Type

Type PROCESS_INFO
    hProcess As Long
    hThread As Long
    dwProcessId As Long
    dwThreadId As Long
End Type

Declare Function CreateProcess Lib "kernel32" Alias "CreateProcessA" _
                    (ByVal lpApplicationName As String, _
                     ByVal lpCommandLine As String, _
                     ByVal lpProcessAttributes As Any, _
                     ByVal lpThreadAttributes As Any, _
                     ByVal bInheritHandles As Long, _
                     ByVal dwCreationFlags As Long, _
                     ByVal lpEnvironment As Any, _
                     ByVal lpCurrentDirectory As String, _
                     lpStartupInfo As STARTUPINFO, _
                     lpProcessInformation As PROCESS_INFO) As Boolean


Declare Function CloseHandle Lib "kernel32.dll" _
                    (ByVal hObject As Long) As Long


Const NORMAL_PRIORITY_CLASS = &H20&
Const STARTF_USESHOWWINDOW = &H1&
Const SW_HIDE = &H0&


Sub Main()

    Dim bSuccess As Boolean
    Dim lRetVal As Long
    Dim sCmdLine As String
    Dim sNull As String
    Dim pInfo As PROCESS_INFO
    Dim sInfo As STARTUPINFO
    Dim sIncidentId As String
    Dim TargetServerName As String
    Dim TargetDatabaseName As String
    
	
    Dim AlarmPointMsg As String

	If RepositoryServerName = "" Then
		TargetServerName = GetMachName()
	Else
		TargetServerName = RepositoryServerName
	End If

	If RepositoryDatabaseName = "" Then
		TargetDatabaseName = "QDB"
	Else
		TargetDatabaseName = RepositoryDatabaseName
	End If

	
	
	On Error GoTo Main_AlarmPointStart
	

Main_AlarmPointStart:
'/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
	If EventIDOverride = "" Then
		If eventID <> 0 Then
			sIncidentId = CStr(eventID)
		Else
			sIncidentId = "Unknown"
		End If

	Else
		sIncidentId = EventIDOverride
	End If
		
    sInfo.dwFlags = STARTF_USESHOWWINDOW
    sInfo.wShowWindow = SW_HIDE
    sInfo.cb = Len(sInfo)
    
    'Build the command line with following token order:
    ' ActionScriptSet, PersonOrGroupID, Situation, Device, IncidentID, EventMsg
    
	If EventMsgOverride <> "" Then
		AlarmPointMsg = EventMsgOverride
	Else
		AlarmPointMsg = EventMsg
	End If

	 sCmdLine = ""
	 sCmdLine = sCmdLine & "c:\apagent\apclient --map-data appmanager " 
	 sCmdLine = sCmdLine & DoubleTic & PersonOrGroupID           & DoubleTic & OneSpace
	 sCmdLine = sCmdLine & DoubleTic & KPName 		     		 & DoubleTic & OneSpace
	 sCmdLine = sCmdLine & DoubleTic & MachineName               & DoubleTic & OneSpace
	 sCmdLine = sCmdLine & DoubleTic & sIncidentId               & DoubleTic & OneSpace
	 sCmdLine = sCmdLine & DoubleTic & AlarmPointMsg             & DoubleTic & OneSpace
	 sCmdLine = sCmdLine & DoubleTic & TargetServerName          & DoubleTic & OneSpace
       sCmdLine = sCmdLine & DoubleTic & TargetDatabaseName      & DoubleTic & OneSpace
	 sCmdLine = sCmdLine & DoubleTic & AlarmPointLoginID         & DoubleTic & OneSpace
	 sCmdLine = sCmdLine & DoubleTic & AlarmPointLoginIDPassword & DoubleTic & OneSpace

    bSuccess = CreateProcess(sNull, sCmdLine, 0&, 0&, _
                             0&, NORMAL_PRIORITY_CLASS, _
                             0&, sNull, sInfo, pInfo)

    

    If (bSuccess = FALSE) Then
        QTrace "CreateProcess '" & sCmdLine & "' failed."
        GoTo ErrHandler
    Else
        QTrace "CreateProcess '" & sCmdLine & "' executed successfully."
        lRetVal = CloseHandle(pInfo.hThread)
        lRetVal = CloseHandle(pInfo.hProcess)
    End If

    MSActions 22, "Success:" & sCmdLine, "AKP_COMPLETE", "", ""
    Exit Sub

ErrHandler:
    MSActions 22, "Failed to execute: ", "AKP_COMPLETE", "", ""
    Exit Sub
End Sub



]]>
</Script>
</ScriptDef>

